#!/bin/bash

function get_password() {
while [ -z "$username" ] || [ -z "$password" ]; do
    read -p "WAS Admin User: " username
    read -s -p "Password: " password

    if [ -z "$username" ] || [ -z "$password" ]; then
        echo "The WAS Admin User and password are required."
    fi
done
}

function get_cert_path() {
    while [ -z certPath ] || [ ! -f "$certPath" ]; do
        read -e -p "Path to certificate: " certPath

        if [ ! -f "$certPath" ]; then 
            echo "The file $certPath does not exists, please enter a valid certificate path."        
        fi
    done

    certPath=$(readlink --canonicalize $certPath)
}

function get_cert_alias() {    
    while [ -z "$certAlias" ]; do
        read -p "Certificate Alias: " certAlias
    done

    if [ -z "$certAlias" ]; then
        echo "The certificate alias is required, please enter a certificate alias."
    fi
}

function read_dom () {
    local IFS=\>
    read -d \< ENTITY CONTENT
    local ret=$?
    TAG_NAME=${ENTITY%% *}
    ATTRIBUTES=${ENTITY#* }
    return $ret
}

function parse_dom () {
    if [[ $TAG_NAME = "property" ]] ; then
        eval local $ATTRIBUTES
        if [[ "$name" = "agent.launch.command" ]]; then
            im_command="$value"
            return
        fi        
    fi
}

function washome_discovery() {

    if [ -f "/var/ibm/InstallationManager/installRegistry.xml" ]; then 
        while read_dom; do
            parse_dom
        done < /var/ibm/InstallationManager/installRegistry.xml

        if [ ! -z "$im_command" ]; then 
            if [ "${im_command: -1}" == "/" ]; then 
                im_command=${im_command::${#im_command}-1}
            fi

            while read path; do
                if [ -f "$path/bin/wsadmin.sh" ]; then
                    wsadmin="$path/bin/wsadmin.sh"                    
                elif [ -f "$path/ConfigTool/wasclient/ThinWsadmin.sh" ]; then
                    wsadmin_thin_client="$path/ConfigTool/wasclient/ThinWsadmin.sh"
                fi
            done < <("$im_command" listInstallationDirectories)
        fi
    fi

    if [ -z "$wsadmin" ] && [ -z "$wsadmin_thin_client" ]; then 

        if [ -f "/opt/.ibm/.was.installlocations.registry" ]; then
            while read path; do
                if [ -f "$path/bin/wsadmin.sh" ]; then
                    wsadmin="$path"
                    break
                fi
            done < /opt/.ibm/.was.installlocations.registry
        fi

        if [ -z "$wsadmin" ]; then
            echo "Unable to discover the wsadmin.sh or ThinWsadmin.sh installation directory, please enter the path to the WebSphere or SMP installation directory."
            while [ -z "$wsadmin" ] || [ ! -f "$wsadmin" ]; do
                read -e -p "Path to WebSphere or SMP directory: " wsadmin

                if [ ! -d "$wsadmin" ]; then 
                    echo "The directory $wsadmin does not exists, please enter a valid WebSphere installation path."
                elif [ -f "$wsadmin/bin/wsadmin.sh" ]; then
                    wsadmin="$wsadmin/bin/wsadmin.sh"
                elif [ -f "$wsadmin/ConfigTool/wasclient/ThinWsadmin.sh" ]; then 
                    wsadmin="$wsadmin/ConfigTool/wasclient/ThinWsadmin.sh"
                else
                    echo  "The directory $wsadmin does not contain the required /bin/wsadmin.sh or /ConfigTool/wasclient/ThinWsadmin.sh script file.  Please enter a valid WebSphere or SMP installation directory."      
                fi
            done
        fi
    fi
}

get_password
echo
washome_discovery

if [ ! -z $wsadmin_thin_client ]; then 
    client=$wsadmin_thin_client
else 
    client=$wsadmin
fi

echo "Attempting to import the Let's Encrypt CA certifcate to WebSphere."

letsEncryptCA="$(readlink --canonicalize ./ca/lets-encrypt-r3-cross-signed.pem)"  

"$client" -lang jython -username "$username" -password "$password" -f ./ca-import.py "$letsEncryptCA" "letsencrypt"

echo "Successfully imported Let's Encrypt CA certificate to WebSphere"